﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.Samples.ServiceHosting.StorageClient;
using Microsoft.Samples.PersonalWebSite_WebRole.Code.Article;

namespace Microsoft.Samples.PersonalWebSite_WebRole.Admin
{
    public partial class ManageArticles : System.Web.UI.Page
    {
     
        IQueryable<Article> query;
        protected void Page_Load(object sender, EventArgs e)
        {
      
            if (!IsPostBack)
            {

                StorageAccountInfo accountInfo = StorageAccountInfo.GetAccountInfoFromConfiguration("TableStorageEndpoint");
                TableStorage.CreateTablesFromModel(typeof(ArticleDataServiceContext), accountInfo);
                ArticleDataServiceContext context = new ArticleDataServiceContext(accountInfo);

                query = context.Articles;
             
                GridView1.DataSource = query;
                GridView1.DataBind();
                
            }
        }

        protected void GridView1_RowEditing(Object sender, GridViewEditEventArgs e)
        {
   

            string rowKey = GridView1.DataKeys[e.NewEditIndex].Value.ToString();
            Response.Redirect("AddOrEdit.aspx?rowKey=" + rowKey);

        }

        protected void GridView1_RowDeleting(Object sender, GridViewDeleteEventArgs e)
        {

            StorageAccountInfo accountInfo = StorageAccountInfo.GetAccountInfoFromConfiguration("TableStorageEndpoint");
            TableStorage.CreateTablesFromModel(typeof(ArticleDataServiceContext), accountInfo);
            ArticleDataServiceContext context = new ArticleDataServiceContext(accountInfo);


            Article c = new Article();
            c.RowKey = GridView1.DataKeys[e.RowIndex].Value.ToString();

            context.DelArticle(c);
            Response.Redirect("ManageArticles.aspx");


        }
    }
}
