﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.Samples.ServiceHosting.StorageClient;

namespace Microsoft.Samples.PersonalWebSite_WebRole.Code.Article
{
    public class ArticleDataServiceContext : TableStorageDataServiceContext
    {
        public ArticleDataServiceContext(StorageAccountInfo accountInfo)
            : base(accountInfo)
        {

        }

    
        public IQueryable<Article> Articles
        {
            get
            {
                return this.CreateQuery<Article>("Articles");
            }

        }

        public IQueryable<Article> GetTop(int n)
        {
            return this.CreateQuery<Article>("Articles").Take(n);
        }

    
        public void AddArticle(Article c)
        {

            this.AddObject("Articles", c);
            this.SaveChanges();
        }

      
        public void DelArticle(Article c)
        {

            this.AttachTo("Articles", c, "*");

            this.DeleteObject(c);
            this.SaveChanges();
        }

     
        public void UpdateArticle(Article c)
        {
            this.AttachTo("Articles", c, "*");
            this.UpdateObject(c);
            this.SaveChanges();
        }
    }
}
