<%@ Import Namespace="Microsoft.Samples.ServiceHosting.AspProviders" %>
<%@ Import Namespace="Microsoft.Samples.ServiceHosting.ClouderaCMS" %>
<%@ Application Language="C#" %>


<script runat="server">
    
    // While running in the fabric environment, RoleManager will not be 
    // initialized yet upon Application_Start.  This is similar to the situation
    // with the http RequestContext object in IIS HWC.  
    
    // The recommended way to do this is by doing the proper initialization
    // upon the first request.  Event handlers installation can still be done in Application_Start

    // For more details on this topic, refer to the Blob Post at 
    // http://mvolo.com/blogs/serverside/archive/2007/11/10/Integrated-mode-Request-is-not-available-in-this-context-in-Application_5F00_Start.aspx

    void Application_Start(object sender, EventArgs e)
    {
        SiteMap.SiteMapResolve += new SiteMapResolveEventHandler(AppendQueryString);
    }
            
    void Application_BeginRequest(object sender, EventArgs e)
    {
        HttpApplication app = (HttpApplication)sender;
        HttpContext context = app.Context;
        FirstRequestInitialization.Initialize(context);
    }
    
    class FirstRequestInitialization
    {
        private static bool s_InitializedAlready = false;
        private static Object s_lock = new Object();

        public static void Initialize(HttpContext context)
        {
            if (s_InitializedAlready)
            {
                return;
            }
            lock (s_lock)
            {
                if (s_InitializedAlready)
                {
                    return;
                }

                ApplicationStartUponFirstRequest(context);
                s_InitializedAlready = true;
            }
        }

        private static void ApplicationStartUponFirstRequest(HttpContext context)
        {
            // This is where you put initialization logic for the site.
            // RoleManager is properly initialized at this point.

            if (!Roles.RoleExists("Administrators")) Roles.CreateRole("Administrators");
            if (!Roles.RoleExists("Friends")) Roles.CreateRole("Friends");
            if (Membership.GetUser("admin") == null)
            {
                Membership.CreateUser("admin", "admin", "admin@mypersonalsite.com");
                Roles.AddUserToRole("admin", "Administrators");
            }

            AlbumTable.Initialize();
            PhotoTable.Initialize();
        }
    }

    SiteMapNode AppendQueryString(object o, SiteMapResolveEventArgs e) {
		if (SiteMap.CurrentNode != null) {
			SiteMapNode temp;
			temp = SiteMap.CurrentNode.Clone(true);
			Uri u = new Uri(e.Context.Request.Url.ToString());
			temp.Url += u.Query;
			if (temp.ParentNode != null) {
				temp.ParentNode.Url += u.Query;
			}
			return temp;
		} else {
			return null;
		}
	}
	
</script>
